#===istalismanplugin===
# -*- coding: utf-8 -*-

#  Talisman plugin
#  order_plugin.py

#  Модификация плагина для комфортной игры в викторину, плюс исправленная работа
#  плагина и расширенные информативные функции
#  + антиреклама
#  mod by Gigabyte
#  www: http://jabbrik.ru
#  mail: gigabyte@ngs.ru
#  xmpp: stalker@conference.jabbers.ru

import re

order_stats = {}
order_obscene_words = [u'бляд', u' блят', u' бля ', u' блять ', u' плять ', u' хуй', u' ибал', u' ебал', u'нахуй', u' хуй', u' хуи', u'хуител', u' хуя', u'хуя', u' хую', u' хуе', u' ахуе', u' охуе', u'хуев', u' хер ', u' хер', u'хер', u' пох ', u' нах ', u'писд', u'пизд', u'рizd', u' пздц ', u' еб', u' епана ', u' епать ', u' ипать ', u' выепать ', u' ибаш', u' уеб', u'проеб', u'праеб', u'приеб', u'съеб', u'сьеб', u'взъеб', u'взьеб', u'въеб', u'вьеб', u'выебан', u'перееб', u'недоеб', u'долбоеб', u'долбаеб', u' ниибац', u' неебац', u' неебат', u' ниибат', u' пидар', u' рidаr', u' пидар', u' пидор', u'педор', u'пидор', u'пидарас', u'пидараз', u' педар', u'педри', u'пидри', u' заеп', u' заип', u' заеб', u'ебучий', u'ебучка ', u'епучий', u'епучка ', u' заиба', u'заебан', u'заебис', u' выеб', u'выебан', u' поеб', u' наеб', u' наеб', u'сьеб', u'взьеб', u'вьеб', u' гандон', u' гондон', u'пахуи', u'похуис', u' манда ', u'мандав', u' залупа', u' залупог']

order_reklama_words = [u'@conference.', u'заходите']

#resmile = re.compile('\*[A-Z_! ]+\*') 

def check_order_obscene_words(body):
	body=body.strip().lower()
	body=u' '+body+u' '
	for x in order_obscene_words:
		if body.count(x):
			return True
	return False

def check_order_reklama_words(body):
	body=body.strip().lower()
	body=u' '+body+u' '
	for x in order_reklama_words:
		if body.count(x):
			return True
	return False

def order_kick(groupchat, nick, reason):
	iq = xmpp.Iq('set')
	iq.setTo(groupchat)
	iq.setID('kick'+str(random.randrange(1000, 9999)))
	query = xmpp.Node('query')
	query.setNamespace('http://jabber.org/protocol/muc#admin')
	kick=query.addChild('item', {'nick':nick, 'role':'none'})
	kick.setTagData('reason', reason)
	iq.addChild(node=query)
	JCON.send(iq)
	
def order_visitor(groupchat, nick):
	iq = xmpp.Iq('set')
	iq.setTo(groupchat)
	iq.setID('kick'+str(random.randrange(1000, 9999)))
	query = xmpp.Node('query')
	query.setNamespace('http://jabber.org/protocol/muc#admin')
	visitor=query.addChild('item', {'nick':nick, 'role':'visitor'})
	iq.addChild(node=query)
	JCON.send(iq)
	
def order_ban(groupchat, nick, reason):
	iq = xmpp.Iq('set')
	iq.setTo(groupchat)
	iq.setID('kick'+str(random.randrange(1000, 9999)))
	query = xmpp.Node('query')
	query.setNamespace('http://jabber.org/protocol/muc#admin')
	ban=query.addChild('item', {'nick':nick, 'affiliation':'outcast'})
	ban.setTagData('reason', reason)
	iq.addChild(node=query)
	JCON.send(iq)
	
def order_unban(groupchat, jid):
	iq = xmpp.Iq('set')
	iq.setTo(groupchat)
	iq.setID('kick'+str(random.randrange(1000, 9999)))
	query = xmpp.Node('query')
	query.setNamespace('http://jabber.org/protocol/muc#admin')
	query.addChild('item', {'jid':jid, 'affiliation':'none'})
	iq.addChild(node=query)
	JCON.send(iq)

def handler_order_message(type, source, body):
        global order_stats
	nick=source[2]
	groupchat=source[1]
	botnick = get_bot_nick(source[1])
	if type=='private':
		return
	if nick in GROUPCHATS[groupchat]:
		if get_bot_nick(groupchat)!= nick and nick!='':
			jid=get_true_jid(groupchat+'/'+nick)
			if groupchat in order_stats and jid in order_stats[groupchat]:
				lastmsg=order_stats[groupchat][jid]['msgtime']
				now = time.time()
				if body != '':
					order_stats[groupchat][jid]['msgtime']=time.time()
					sourcebody=body
					body = body.lower().replace(' ', '').strip()
					if GCHCFGS[groupchat]['filt']['smile']==1:
#						sml=re.findall(resmile, sourcebody)
#						print sml
                                                limsml = GCHCFGS[groupchat]['filt']['const']['smileforkick']
						if body.count('-)') > limsml or body.count('-(') > limsml:
#							order_stats[groupchat][jid]['flood']+=1
							order_stats[groupchat][jid]['devoice']['time']=now
							order_stats[groupchat][jid]['devoice']['cnd']=1
							reply(type, source, u'Смайл флуд!')
							order_stats[groupchat][jid]['cause'] = u'смайл флуд'
							order_kick(groupchat, nick, u'смайл-флуд, kick from '+botnick)
							return
					if (GCHCFGS[groupchat]['filt']['time']==1) & (not QUIZ_CURRENT_ANSWER.has_key(source[1])):
						if now-lastmsg<=2.2:
							order_stats[groupchat][jid]['msg']+=1
							if order_stats[groupchat][jid]['msg']>2:
#								order_stats[groupchat][jid]['flood']+=1
								order_stats[groupchat][jid]['devoice']['time']=now
								order_stats[groupchat][jid]['devoice']['cnd']=1
								order_stats[groupchat][jid]['msg']=0
								order_stats[groupchat][jid]['cause'] = u'быстро отправлял'
								reply(type, source, u'Слишком быстро отправляешь!')
								order_kick(groupchat, nick, u'слишком быстро отправляешь, kick from '+botnick)
								return
					if (GCHCFGS[groupchat]['filt']['len']==1) & (not QUIZ_CURRENT_ANSWER.has_key(source[1])):
						if len(sourcebody)>900:
#							order_stats[groupchat][jid]['flood']+=1
							order_stats[groupchat][jid]['devoice']['time']=now
							order_stats[groupchat][jid]['devoice']['cnd']=1
							order_stats[groupchat][jid]['cause'] = u'флуд'
							reply(type, source, u'Охтунг!')
							order_kick(groupchat, nick, u'флуд, kick from '+botnick)
							return
					if GCHCFGS[groupchat]['filt']['obscene']==1:
						if check_order_obscene_words(sourcebody):
#							order_stats[groupchat][jid]['obscene']+=1
							order_stats[groupchat][jid]['devoice']['time']=now
							order_stats[groupchat][jid]['devoice']['cnd']=1
							order_stats[groupchat][jid]['cause'] = u'мат'
							reply(type, source, u'У нас не матерятся!')
							order_kick(groupchat, nick, u'маты фтопку, kick from '+botnick)
							return
					if GCHCFGS[groupchat]['filt']['reklama']==1:
						if check_order_reklama_words(sourcebody):
#							order_stats[groupchat][jid]['obscene']+=1
							order_stats[groupchat][jid]['devoice']['time']=now
							order_stats[groupchat][jid]['devoice']['cnd']=1
							order_stats[groupchat][jid]['cause'] = u'реклама'
							reply(type, source, u'У нас нельзя рекламить!')
							order_kick(groupchat, nick, u'рекламу фтопку, kick from '+botnick)
							return
					if GCHCFGS[groupchat]['filt']['caps']==1:
						ccnt=0
						nicks = GROUPCHATS[groupchat].keys()
						sbody=sourcebody
						for x in nicks:
							if sbody.count(x):
								sbody=sbody.replace(x,'')
#						if sourcebody.strip().split()[0].replace(':', '').replace(',', '').replace('>', '') in nicks:
#							sourcebody=' '.join(sourcebody.split()[1:]).strip()
						for x in [x for x in sbody.replace(' ', '').strip()]:
							if x.isupper():
								ccnt+=1
						if ccnt>=len(sbody)/2 and ccnt>9:
#							order_stats[groupchat][jid]['flood']+=1
							order_stats[groupchat][jid]['devoice']['time']=now
							order_stats[groupchat][jid]['devoice']['cnd']=1
							order_stats[groupchat][jid]['cause'] = u'капс'
							reply(type, source, u'Не капси!')
							order_kick(groupchat, nick, u'слишком много капса, kick from '+botnick)
							return
					if GCHCFGS[groupchat]['filt']['like']==1:
						lcnt=0
						if order_stats[groupchat][jid]['msgbody'] is not None:
							if now-lastmsg>60:
								order_stats[groupchat][jid]['msgbody']=sourcebody.strip().split()
							else:
								for x in order_stats[groupchat][jid]['msgbody']:
									for y in sourcebody.strip().split():
										if x==y:
											lcnt+=1
								if lcnt:
									lensrcmsgbody=len(sourcebody.strip().split())
									lenoldmsgbody=len(order_stats[groupchat][jid]['msgbody'])
									avg=(lensrcmsgbody+lenoldmsgbody/2)/2
									if lcnt>avg:
										order_stats[groupchat][jid]['msg']+=1
										if (order_stats[groupchat][jid]['msg']>=2) & (not QUIZ_CURRENT_ANSWER.has_key(source[1])):
#											order_stats[groupchat][jid]['flood']+=1
											order_stats[groupchat][jid]['devoice']['time']=now
											order_stats[groupchat][jid]['devoice']['cnd']=1
											order_stats[groupchat][jid]['msg']=0
											order_stats[groupchat][jid]['cause'] = u'похожие мессаги'
											reply(type, source, u'Похожие мессаги!')
											order_kick(groupchat, nick, u'мессаги слишком похожи, kick from '+botnick)
											return
								order_stats[groupchat][jid]['msgbody']=sourcebody.strip().split()
						else:
							order_stats[groupchat][jid]['msgbody']=sourcebody.strip().split()
						
def handler_order_join(groupchat, nick, aff, role):
        global order_stats
        devtime = GCHCFGS[groupchat]['filt']['const']['timedevoice']
	botnick = get_bot_nick(groupchat+'/'+nick)
	jid=get_true_jid(groupchat+'/'+nick)
	if nick in GROUPCHATS[groupchat]:
		now = time.time()
		if not groupchat in order_stats.keys():
			order_stats[groupchat] = {}
		if (jid in order_stats[groupchat].keys()):
			if (order_stats[groupchat][jid]['devoice']['cnd']==1) & (aff in ['none', 'member']):
				if now-order_stats[groupchat][jid]['devoice']['time']>devtime:
					order_stats[groupchat][jid]['devoice']['cnd']=0
				else:
                                        msg(groupchat+'/'+nick, u'Наказан за "'+order_stats[groupchat][jid]['cause']+u'". Осталось ещё '+sectomin( devtime - int(now-order_stats[groupchat][jid]['devoice']['time']) ))
					order_visitor(groupchat, nick)
#			if order_stats[groupchat][jid]['obscene']>=1:
#				order_visitor(groupchat, nick)
#			if order_stats[groupchat][jid]['flood']!=0:
#				if order_stats[groupchat][jid]['flood']<3:
#					order_visitor(groupchat, nick)
#				elif order_stats[groupchat][jid]['flood']>3:
#					order_stats[groupchat][jid]['flood']=0
#					order_ban(groupchat, nick, 'слишком много флуда')
			if GCHCFGS[groupchat]['filt']['kicks']['cond']==1:
				kcnt=GCHCFGS[groupchat]['filt']['kicks']['cnt']
				if order_stats[groupchat][jid]['kicks']>kcnt:
					order_ban(groupchat, nick, u'слишком много киков')

			if GCHCFGS[groupchat]['filt']['fly']['cond']==1:
				lastprs=order_stats[groupchat][jid]['prstime']['fly']
				order_stats[groupchat][jid]['prstime']['fly']=time.time()	
				if now-lastprs<=70:
					order_stats[groupchat][jid]['prs']['fly']+=1
					if order_stats[groupchat][jid]['prs']['fly']>4:
						order_stats[groupchat][jid]['prs']['fly']=0
						fmode=GCHCFGS[groupchat]['filt']['fly']['mode']
						ftime=GCHCFGS[groupchat]['filt']['fly']['time']
						if fmode=='ban':
                                                        reply('public', [groupchat+'/'+nick, groupchat, nick], u'Угамонись уже!')
							order_ban(groupchat, nick, u'хватит летать, ban from '+botnick+u', on '+str(ftime)+u'sec')
							time.sleep(ftime)
							order_unban(groupchat, jid)
						else:
                                                        reply('public', [groupchat+'/'+nick, groupchat, nick], u'Угамонись уже!')
							order_kick(groupchat, nick, u'хватит летать, kick form '+botnick)
				else:
					order_stats[groupchat][jid]['prs']['fly']=0

		elif nick in GROUPCHATS[groupchat]:
			order_stats[groupchat][jid]={}
			order_stats[groupchat][jid]['kicks']=0
#			order_stats[groupchat][jid]['obscene']=0
#			order_stats[groupchat][jid]['flood']=0
			order_stats[groupchat][jid]['devoice']={}
			order_stats[groupchat][jid]['devoice']['cnd']=0
			order_stats[groupchat][jid]['devoice']['time']=0
			order_stats[groupchat][jid]['msgbody']=None
			order_stats[groupchat][jid]['msgtime']=0
			order_stats[groupchat][jid]['prstime']={}
			order_stats[groupchat][jid]['prstime']['fly']=0
			order_stats[groupchat][jid]['prstime']['status']=0			
			order_stats[groupchat][jid]['prs']={}
			order_stats[groupchat][jid]['prs']['fly']=0
			order_stats[groupchat][jid]['prs']['status']=0
			order_stats[groupchat][jid]['msg']=0

	elif groupchat in order_stats and jid in order_stats[groupchat]:
                pass
		#del order_stats[groupchat][jid]
	else:
		pass			

def handler_order_presence(prs):
        global order_stats
	ptype = prs.getType()
	if ptype=='unavailable' or ptype=='error':
		return
	groupchat = prs.getFrom().getStripped()
	nick = prs.getFrom().getResource()
	stmsg = prs.getStatus()
	jid=get_true_jid(groupchat+'/'+nick)
	item=findPresenceItem(prs)
	botnick = get_bot_nick(groupchat+'/'+nick)
	
	if groupchat in order_stats and jid in order_stats[groupchat]:
		if (item['affiliation']=='none') | (item['affiliation']=='member') | (item['affiliation']=='admin')  | (item['affiliation']=='owner'):
                        pass
			#del order_stats[groupchat][jid]
			#return
		if 1==2 & ((item['affiliation']=='none') | (item['affiliation']=='member') | (item['affiliation']=='admin')  | (item['affiliation']=='owner')):
			order_stats[groupchat][jid]={}
			order_stats[groupchat][jid]['kicks']=0
#			order_stats[groupchat][jid]['obscene']=0
#			order_stats[groupchat][jid]['flood']=0
			order_stats[groupchat][jid]['devoice']={}
			order_stats[groupchat][jid]['devoice']['cnd']=0
			order_stats[groupchat][jid]['devoice']['time']=0
			order_stats[groupchat][jid]['msgbody']=None
			order_stats[groupchat][jid]['msgtime']=0
			order_stats[groupchat][jid]['prstime']={}
			order_stats[groupchat][jid]['prstime']['fly']=0
			order_stats[groupchat][jid]['prstime']['status']=0			
			order_stats[groupchat][jid]['prs']={}
			order_stats[groupchat][jid]['prs']['fly']=0
			order_stats[groupchat][jid]['prs']['status']=0
			order_stats[groupchat][jid]['msg']=0			

	if nick in GROUPCHATS[groupchat]:
		now = time.time()
		if now-GROUPCHATS[groupchat][nick]['joined']>1:
			if item['role']=='participant':
				order_stats[groupchat][jid]['devoice']['cnd']=0
			lastprs=order_stats[groupchat][jid]['prstime']['status']
			order_stats[groupchat][jid]['prstime']['status']=time.time()
			if GCHCFGS[groupchat]['filt']['presence']==1:
				if now-lastprs>300:
					order_stats[groupchat][jid]['prs']['status']=0
				else:
					order_stats[groupchat][jid]['prs']['status']+=1
					if order_stats[groupchat][jid]['prs']['status']>5:
						order_stats[groupchat][jid]['prs']['status']=0
						order_kick(groupchat, nick, u'презенс-флуд, kick from '+botnick)
						return
			if GCHCFGS[groupchat]['filt']['prsstlen']==1 and stmsg:
				if len(stmsg)>=200:
					order_stats[groupchat][jid]['flood']+=1
					order_kick(groupchat, nick, u'статусная мессага слишком большая, kick from '+botnick)						
				order_stats[groupchat][jid]['prstime']['status']=time.time()
				
	elif groupchat in order_stats and jid in order_stats[groupchat]:
                pass
		#del order_stats[groupchat][jid]
	else:
		pass		

#		elif ptype=='unavailable':
#			try:
#				lastprs=order_stats[groupchat][jid]['prstime']['fly']
#				if now-lastprs<=70:
#					if now-lastprs>=300:
#						order_stats[groupchat][jid]['prs']['fly']=0
#					else:
#						order_stats[groupchat][jid]['prs']['fly']+=1
#						if order_stats[groupchat][jid]['prs']['fly']>5:
#							order_stats[groupchat][jid]['prs']['fly']=0
#							order_kick(groupchat, nick, 'flying flood')
#				order_stats[groupchat][jid]['prstime']['fly']=time.time()
#			except:
#				pass
			
#		if check_order_obscene_words(GROUPCHATS[groupchat][nick]['stmsg']):
#			order_stats[groupchat][jid]['obscene']+=1
#			order_kick(groupchat, nick, 'obscene lexicon in status msg')	
			
#			order_stats[groupchat][jid]['prs']=0
#			code = prs.getStatusCode()
#			if code:
#				if groupchat in order_stats.keys():
#					if jid in order_stats[groupchat].keys():
#						if code == '307': # kick
#							order_stats[groupchat][jid]['kicked']+=1
#						if code == '301': # ban
#							del order_stats[groupchat][jid]

def handler_order_leave(groupchat, nick, reason, code):
        global order_stats
	jid=get_true_jid(groupchat+'/'+nick)
	if nick in GROUPCHATS[groupchat]:
		if GCHCFGS[groupchat]['filt']['presence']==1:
			if reason=='Replaced by new connection':
				return
			if code:
				if code=='307': # kick
					order_stats[groupchat][jid]['kicks']+=1
					return
				elif code=='301': # ban
					del order_stats[groupchat][jid]
					return
				elif code=='407': # members-only
					return
		if GCHCFGS[groupchat]['filt']['fly']['cond']==1:
			now = time.time()
			lastprs=order_stats[groupchat][jid]['prstime']['fly']
			order_stats[groupchat][jid]['prstime']['fly']=time.time()
			if now-lastprs<=70:
				order_stats[groupchat][jid]['prs']['fly']+=1
			else:
				order_stats[groupchat][jid]['prs']['fly']=0
	elif groupchat in order_stats and jid in order_stats[groupchat]:
                pass
		#del order_stats[groupchat][jid]
	else:
		pass		


######################################################################################################################

def handler_order_filt(type, source, parameters):
        global order_stats
	if parameters:
		parameters=parameters.split()
		if len(parameters)<2:
			reply(type,source,u'синтакс инвалид')
			return
		if GCHCFGS[source[1]].has_key('filt'):
			if (parameters[0]=='smile') | (parameters[0]==u'смайл'):
				if parameters[1]=='0':
					reply(type,source,u'фильтрация смайлов отключена')
					GCHCFGS[source[1]]['filt']['smile']=0
				elif parameters[1]=='1':
					reply(type,source,u'фильтрация смайлов включена')
					GCHCFGS[source[1]]['filt']['smile']=1
				else:
					reply(type,source,u'синтакс инвалид')
			elif (parameters[0]=='smlkick'):
                                if int(parameters[1])>0:
                                        reply(type,source,u'количество смайлов "смайл-флуда" изменено на '+parameters[1])
                                        GCHCFGS[source[1]]['filt']['const']['smileforkick']=int(parameters[1])
			elif (parameters[0]=='timedev'):
                                if int(parameters[1])>0:
                                        reply(type,source,u'время де-войса изменено на '+parameters[1])
                                        GCHCFGS[source[1]]['filt']['const']['timedevoice']=int(parameters[1])


			elif (parameters[0]=='time') | (parameters[0]==u'время'):
				if parameters[1]=='0':
					reply(type,source,u'временная фильтрация сообщений отключена')
					GCHCFGS[source[1]]['filt']['time']=0
				elif parameters[1]=='1':
					reply(type,source,u'временная фильтрация сообщений включена')
					GCHCFGS[source[1]]['filt']['time']=1
				else:
					reply(type,source,u'синтакс инвалид')
			elif (parameters[0]=='presence') | (parameters[0]==u'презенс'):
				if parameters[1]=='0':
					reply(type,source,u'временная фильтрация презенсов отключена')
					GCHCFGS[source[1]]['filt']['presence']=0
				elif parameters[1]=='1':
					reply(type,source,u'временная фильтрация презенсов включена')
					GCHCFGS[source[1]]['filt']['presence']=1
				else:
					reply(type,source,u'синтакс инвалид')
			elif (parameters[0]=='reklama') | (parameters[0]==u'реклама'):
				if parameters[1]=='0':
					reply(type,source,u'фильтрация рекламы отключена')
					GCHCFGS[source[1]]['filt']['reklama']=0
				elif parameters[1]=='1':
					reply(type,source,u'фильтрация рекламы включена')
					GCHCFGS[source[1]]['filt']['reklama']=1
				else:
					reply(type,source,u'синтакс инвалид')
			elif (parameters[0]=='len') | (parameters[0]==u'длинный'):
				if parameters[1]=='0':
					reply(type,source,u'фильтрация длинных сообщений отключена')
					GCHCFGS[source[1]]['filt']['len']=0
				elif parameters[1]=='1':
					reply(type,source,u'фильтрация длинных сообщений включена')
					GCHCFGS[source[1]]['filt']['len']=1
				else:
					reply(type,source,u'синтакс инвалид')
			elif (parameters[0]=='like') | (parameters[0]==u'подозрительные'):
				if parameters[1]=='0':
					reply(type,source,u'фильтрация подозрительно одинаковых сообщений отключена')
					GCHCFGS[source[1]]['filt']['like']=0
				elif parameters[1]=='1':
					reply(type,source,u'фильтрация подозрительно одинаковых сообщений включена')
					GCHCFGS[source[1]]['filt']['like']=1
				else:
					reply(type,source,u'синтакс инвалид')
			elif (parameters[0]=='caps') | (parameters[0]==u'капс'):
				if parameters[1]=='0':
					reply(type,source,u'фильтрация капса отключена')
					GCHCFGS[source[1]]['filt']['caps']=0
				elif parameters[1]=='1':
					reply(type,source,u'фильтрация капса включена')
					GCHCFGS[source[1]]['filt']['caps']=1
				else:
					reply(type,source,u'синтакс инвалид')	
			elif (parameters[0]=='prsstlen') | (parameters[0]==u'статус'):
				if parameters[1]=='0':
					reply(type,source,u'фильтрация длинных статусных сообщений отключена')
					GCHCFGS[source[1]]['filt']['prsstlen']=0
				elif parameters[1]=='1':
					reply(type,source,u'фильтрация длинных статусных сообщений включена')
					GCHCFGS[source[1]]['filt']['prsstlen']=1
				else:
					reply(type,source,u'синтакс инвалид')
			elif (parameters[0]=='obscene') | (parameters[0]==u'мат'):
				if parameters[1]=='0':
					reply(type,source,u'фильтрация мата отключена')
					GCHCFGS[source[1]]['filt']['obscene']=0
				elif parameters[1]=='1':
					reply(type,source,u'фильтрация мата включена')
					GCHCFGS[source[1]]['filt']['obscene']=1
				else:
					reply(type,source,u'синтакс инвалид')
			elif (parameters[0]=='fly')  | (parameters[0]==u'полёт'):
				if parameters[1]=='cnt':
					try:
						int(parameters[2])
					except:
						reply(type,source,u'синтакс инвалид')
					if int(parameters[2]) in xrange(0,121):
						reply(type,source,u'разморозка установлена на '+parameters[2]+u' секунд')
						GCHCFGS[source[1]]['filt']['fly']['time']=int(parameters[2])	
					else:
						reply(type,source,u'не более двух минут (120 секунд)')
				elif parameters[1]=='mode':
					if parameters[2] in ['kick','ban']:
						if parameters[2] == 'ban':
							reply(type,source,u'за полёты будем банить')
							GCHCFGS[source[1]]['filt']['fly']['mode']='ban'
						else:
							reply(type,source,u'за полёты будем кикать')
							GCHCFGS[source[1]]['filt']['fly']['mode']='kick'	
					else:
						reply(type,source,u'синтакс инвалид')		
				elif parameters[1]=='0':
					reply(type,source,u'фильтр полётов отключен')
					GCHCFGS[source[1]]['filt']['fly']['cond']=0
				elif parameters[1]=='1':
					reply(type,source,u'фильтр полётов включен')
					GCHCFGS[source[1]]['filt']['fly']['cond']=1
				else:
					reply(type,source,u'синтакс инвалид')
			elif (parameters[0]=='kicks')  | (parameters[0]==u'кики'):
				if parameters[1]=='cnt':
					try:
						int(parameters[2])
					except:
						reply(type,source,u'синтакс инвалид')
					if int(parameters[2]) in xrange(2,10):
						reply(type,source,u'автобан после '+parameters[2]+u' киков')
						GCHCFGS[source[1]]['filt']['kicks']['cnt']=int(parameters[2])	
					else:
						reply(type,source,u'от 2 до 10 киков')
				elif parameters[1]=='0':
					reply(type,source,u'фильтр автобана после нескольких киков отключен')
					GCHCFGS[source[1]]['filt']['kicks']['cond']=0
				elif parameters[1]=='1':
					reply(type,source,u'фильтр автобана после нескольких киков включен')
					GCHCFGS[source[1]]['filt']['kicks']['cond']=1
				else:
					reply(type,source,u'синтакс инвалид')
			else:
				reply(type,source,u'синтакс инвалид')
				return					
			DBPATH='dynamic/'+source[1]+'/config.cfg'
			write_file(DBPATH, str(GCHCFGS[source[1]]))
		else:
			reply(type,source,u'случилось что-то странное, ткните админа бота')
	else:
		rep,foff,fon=u'',[],[]
		smile=GCHCFGS[source[1]]['filt']['smile']
		time=GCHCFGS[source[1]]['filt']['time']
		prs=GCHCFGS[source[1]]['filt']['presence']
		rkm=GCHCFGS[source[1]]['filt']['reklama']
		flen=GCHCFGS[source[1]]['filt']['len']
		like=GCHCFGS[source[1]]['filt']['like']
		caps=GCHCFGS[source[1]]['filt']['caps']
		prsstlen=GCHCFGS[source[1]]['filt']['prsstlen']
		obscene=GCHCFGS[source[1]]['filt']['obscene']
		fly=GCHCFGS[source[1]]['filt']['fly']['cond']
		flytime=str(GCHCFGS[source[1]]['filt']['fly']['time'])
		flymode=GCHCFGS[source[1]]['filt']['fly']['mode']
		kicks=GCHCFGS[source[1]]['filt']['kicks']['cond']
		kickscnt=str(GCHCFGS[source[1]]['filt']['kicks']['cnt'])
		if smile:
			fon.append(u'фильтрация смайлов')
		else:
			foff.append(u'фильтрация смайлов')
		if time:
			fon.append(u'временная фильтрация сообщений')
		else:
			foff.append(u'временная фильтрация сообщений')
		if prs:
			fon.append(u'временная фильтрация презенсов')
		else:
			foff.append(u'временная фильтрация презенсов')
		if flen:
			fon.append(u'фильтрация длинных сообщений')
		else:
			foff.append(u'фильтрация длинных сообщений')
		if rkm:
			fon.append(u'фильтрация рекламы')
		else:
			foff.append(u'фильтрация рекламы')
		if like:
			fon.append(u'фильтрация подозрительно одинаковых сообщений')
		else:
			foff.append(u'фильтрация подозрительно одинаковых сообщений')
		if caps:
			fon.append(u'фильтрация капса')
		else:
			foff.append(u'фильтрация капса')
		if prsstlen:
			fon.append(u'фильтрация длинных статусных сообщений')
		else:
			foff.append(u'фильтрация длинных статусных сообщений')
		if obscene:
			fon.append(u'фильтрация мата')
		else:
			foff.append(u'фильтрация мата')
		if fly:
			fon.append(u'фильтр полётов (режим '+flymode+u', таймер '+flytime+u' секунд)')
		else:
			foff.append(u'фильтр полётов')
		if kicks:
			fon.append(u'автобан после '+kickscnt+u' киков')
		else:
			foff.append(u'автобан после нескольких киков')
		fon=u', '.join(fon)
		foff=u', '.join(foff)
		if fon:
			rep+=u'ВКЛЮЧЕНЫ\n'+fon+u'\n\n'
		if foff:
			rep+=u'ВЫКЛЮЧЕНЫ\n'+foff
		const = u'\nКонстанты:\n'+u'Количество смайлов "смайл-флуд": '+str(GCHCFGS[source[1]]['filt']['const']['smileforkick'])+u'\nВремя девойса: '+str(GCHCFGS[source[1]]['filt']['const']['timedevoice'])
		reply(type,source,rep.strip()+const)


register_message_handler(handler_order_message)
register_join_handler(handler_order_join)
register_leave_handler(handler_order_leave)
register_presence_handler(handler_order_presence)
register_command_handler(handler_order_filt, 'filt', ['админ','мук','все'], 20, 'Включает или отключает определённые фильтры для конференции.\nsmile - фильтр смайлов\ntime - временной фильтр\nlen - количественный фильтр\npresence - фильтр презенсов\nlike - фильтр одинаковых сообщений\ncaps - фильтр капса (ЗАГЛАВНЫХ букв)\nprsstlen - фильтр длинных статусных сообщений\nobscene - фильтр матов\nfly - фильтр полётов (частых входов/выходов в конмату), имеет два режима ban и kick, таймер от 0 до 120 секунд\nkicks - автобан после N киков, параметр cnt - количество киков от 1 до 10', 'filt [фильтр] [режим] [состояние]', ['filt smile 1', 'filt len 0','filt fly mode ban'])
